<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/cv_ptr_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>03/15/85  cv_ptr_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>
<span id="L4" class="LineNr"> 4 </span>Entry points in cv_ptr_:
<span id="L5" class="LineNr"> 5 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L6" class="LineNr"> 6 </span>
<span id="L7" class="LineNr"> 7 </span>
<span id="L8" class="LineNr"> 8 </span>:Entry:  cv_ptr_:  03/15/85  cv_ptr_
<span id="L9" class="LineNr"> 9 </span>
<span id="L10" class="LineNr">10 </span>
<span id="L11" class="LineNr">11 </span>Function:
<span id="L12" class="LineNr">12 </span>The cv_ptr_ function converts a virtual pointer to a pointer value.  A
<span id="L13" class="LineNr">13 </span>virtual pointer is a character-string representation of a pointer
<span id="L14" class="LineNr">14 </span>value.
<span id="L15" class="LineNr">15 </span>
<span id="L16" class="LineNr">16 </span>
<span id="L17" class="LineNr">17 </span>Syntax:
<span id="L18" class="LineNr">18 </span>declare cv_ptr_ entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span> returns <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L19" class="LineNr">19 </span>ptr_value = cv_ptr_ <span class="textRainbow_lv0_p0">(</span>vptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L20" class="LineNr">20 </span>
<span id="L21" class="LineNr">21 </span>
<span id="L22" class="LineNr">22 </span>Arguments:
<span id="L23" class="LineNr">23 </span>vptr
<span id="L24" class="LineNr">24 </span>   is the virtual pointer to be converted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L25" class="LineNr">25 </span>code
<span id="L26" class="LineNr">26 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L27" class="LineNr">27 </span>ptr_value
<span id="L28" class="LineNr">28 </span>   is the pointer that results from the conversion.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L29" class="LineNr">29 </span>
<span id="L30" class="LineNr">30 </span>
<span id="L31" class="LineNr">31 </span>:Entry:  terminate:  03/15/85 cv_ptr_$terminate
<span id="L32" class="LineNr">32 </span>
<span id="L33" class="LineNr">33 </span>
<span id="L34" class="LineNr">34 </span>Function:  This entry point is called to terminate the segment that has
<span id="L35" class="LineNr">35 </span>been initiated by a previous call to cv_ptr_.
<span id="L36" class="LineNr">36 </span>
<span id="L37" class="LineNr">37 </span>
<span id="L38" class="LineNr">38 </span>Syntax:
<span id="L39" class="LineNr">39 </span>declare cv_ptr_$terminate <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L40" class="LineNr">40 </span>call cv_ptr_$terminate <span class="textRainbow_lv0_p0">(</span>ptr_value<span class="textRainbow_lv0_p0">)</span>;
<span id="L41" class="LineNr">41 </span>
<span id="L42" class="LineNr">42 </span>
<span id="L43" class="LineNr">43 </span>Arguments:
<span id="L44" class="LineNr">44 </span>ptr_value
<span id="L45" class="LineNr">45 </span>   is the pointer returned by the previous call to cv_ptr_.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L46" class="LineNr">46 </span>
<span id="L47" class="LineNr">47 </span>
<span id="L48" class="LineNr">48 </span>Notes:  Pointers returned by the cv_ptr_ function cannot be used as
<span id="L49" class="LineNr">49 </span>entry pointers.  The cv_ptr_ function constructs the returned pointer
<span id="L50" class="LineNr">50 </span>to a segment in a way that avoids copying of the segment's linkage and
<span id="L51" class="LineNr">51 </span>internal static data into the combined linkage area.  The cv_entry_
<span id="L52" class="LineNr">52 </span>function is used to convert virtual entries to an entry value.
<span id="L53" class="LineNr">53 </span>
<span id="L54" class="LineNr">54 </span>The segment pointed to by the returned ptr_value is initiated with a
<span id="L55" class="LineNr">55 </span>null reference name.  The cv_ptr_$terminate entry point should be
<span id="L56" class="LineNr">56 </span>called to terminate this null reference name.
<span id="L57" class="LineNr">57 </span>
<span id="L58" class="LineNr">58 </span>
<span id="L59" class="LineNr">59 </span>Virtual pointers:
<span id="L60" class="LineNr">60 </span>The cv_ptr_ function converts virtual pointers that contain one or two
<span id="L61" class="LineNr">61 </span>components -- a segment identifier and an optional offset into the
<span id="L62" class="LineNr">62 </span>segment.  Altogether, seventeen forms are accepted.  A description of
<span id="L63" class="LineNr">63 </span>virtual pointers can be found in &quot;virtual_pointers.gi.info&quot;.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
